BookManagement.Mvc/Models/ErrorViewModel.cs
using System;

namespace BookManagement.Mvc.Models
{
    public class ErrorViewModel
    {
        public string RequestId { get; set; }

        public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);
    }
}

BookManagement.Mvc/Controllers/BookController.cs
using AutoMapper;
using BookManagement.Application.Features.Books;
using BookManagement.Application.Features.Books.Commands;
using BookManagement.Application.Features.Books.Queries;
using BookManagement.Application.Features.Categories.Queries;
using BookManagement.Application.Features.Categories.Queries.GetCategoriesList;
using MediatR;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace BookManagement.Mvc.Controllers
{
    public class BookController : Controller
    {
        private readonly IMediator _mediator;
        private readonly IMapper _mapper;

        public BookController(IMediator mediator, IMapper mapper)
        {
            _mediator = mediator;
            _mapper = mapper;
        }
        public async Task<IActionResult> Index()
        {
            var query = new GetAllBooksQuery();
            return View(await _mediator.Send(query));
        }

        public async Task<IActionResult> Details(int id)
        {
            var query = new GetBookByIdQuery() { Id = id };
            return View(await _mediator.Send(query));
        }

        public IActionResult Create()
        {
            var createBookCommand = new CreateBookCommand();
            createBookCommand.Categories = GetAllCategories();
            return View(createBookCommand);
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create(CreateBookCommand command)
        {
            try
            {
                if (ModelState.IsValid)
                {
                    await _mediator.Send(command);
                    return RedirectToAction(nameof(Index));
                }
            }
            catch (Exception ex)
            {
                ModelState.AddModelError("", "Unable to save changes.");
            }
            return View(command);
        }

        public async Task<IActionResult> Edit(int id)
        {
            var getBookByIdResponseModel = await _mediator.Send(new GetBookByIdQuery() { Id = id });
            var updateBookCommand = _mapper.Map<UpdateBookCommand>(getBookByIdResponseModel);
            updateBookCommand.Categories = GetAllCategories();

            return View(updateBookCommand);
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Edit(UpdateBookCommand command)
        {
            try
            {
                if (ModelState.IsValid)
                {
                    await _mediator.Send(command);
                    return RedirectToAction(nameof(Index));
                }
            }
            catch (Exception ex)
            {
                ModelState.AddModelError("", "Unable to save changes.");
            }
            return View(command);
        }

        [HttpGet]
        public async Task<IActionResult> Delete(int id)
        {
            try
            {
                await _mediator.Send(new DeleteBookCommand() { Id = id });
            }
            catch (Exception ex)
            {
                ModelState.AddModelError("", "Unable to delete. ");
            }

            return RedirectToAction(nameof(Index));
        }

        private List<CategoryListVm> GetAllCategories()
        {
            var query = new GetCategoriesListQuery();
            return _mediator.Send(query).Result.ToList();
        }
    }
}

BookManagement.Mvc/Controllers/CategoryController.cs
using AutoMapper;
using BookManagement.Application.Features.Categories.Commands.CreateCategory;
using BookManagement.Application.Features.Categories.Commands.UpdateCategory;
using BookManagement.Application.Features.Categories.Queries.GetCategoriesList;
using BookManagement.Application.Features.Categories.Queries.GetCategoryById;
using MediatR;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace BookManagement.Mvc.Controllers
{
    public class CategoryController : Controller
    {
        private readonly IMediator _mediator;
        private readonly IMapper _mapper;

        public CategoryController(IMediator mediator,IMapper mapper)
        {
            _mediator = mediator;
            _mapper = mapper;
        }
        public async Task<IActionResult> Index()
        {
            var query = new GetCategoriesListQuery();
            return View(await _mediator.Send(query));
        }
        public IActionResult Create()
        {
            return View();
        }
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create(CreateCategoryCommand command)
        {
            try
            {
                if (ModelState.IsValid)
                {
                    await _mediator.Send(command);
                    return RedirectToAction(nameof(Index));
                }
            }
            catch (Exception ex)
            {
                ModelState.AddModelError("", "Unable to save changes.");
            }
            return View(command);
        }
        
        public async Task<IActionResult> Edit(int id)
        {
            var getCategoryByIdVm = await _mediator.Send(new GetCategoryByIdQuery() { Id = id });
            var updateCategoryCommand = _mapper.Map<UpdateCategoryCommand>(getCategoryByIdVm);
            return View(updateCategoryCommand);
        }
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Edit(UpdateCategoryCommand command)
        {
            try
            {
                if (ModelState.IsValid)
                {
                    await _mediator.Send(command);
                    return RedirectToAction(nameof(Index));
                }
            }
            catch (Exception ex)
            {
                ModelState.AddModelError("", "Unable to save changes.");
            }
            return View(command);
        }
    }
}

BookManagement.Mvc/Controllers/HomeController.cs
using BookManagement.Mvc.Models;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;

namespace BookManagement.Mvc.Controllers
{
    public class HomeController : Controller
    {
        private readonly ILogger<HomeController> _logger;

        public HomeController(ILogger<HomeController> logger)
        {
            _logger = logger;
        }

        public IActionResult Index()
        {
            return View();
        }

        public IActionResult Privacy()
        {
            return View();
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}

BookManagement.Mvc/Views/Book/Create.cshtml
@model BookManagement.Application.Features.Books.Commands.CreateBookCommand
@{
    ViewData["Title"] = "Create";
}

<div class="card">
    <div class="card-header">Create Book</div>
    <div class="card-body">
        <form asp-action="Create" method="post" autocomplete="off">
            <div class="form-group row">
                <label asp-for="Title" class="col-sm-2 col-form-label"></label>
                <div class="col-sm-4">
                    <input asp-for="Title" class="form-control" />
                    <span asp-validation-for="Title" class="text-danger"></span>
                </div>
                <label asp-for="Publisher" class="col-sm-2 col-form-label"></label>
                <div class="col-sm-4">
                    <input asp-for="Publisher" class="form-control" />
                    <span asp-validation-for="Publisher" class="text-danger"></span>
                </div>
            </div>
            <div class="form-group row">
                <label asp-for="ISBN" class="col-sm-2 col-form-label"></label>
                <div class="col-sm-4">
                    <input asp-for="ISBN" class="form-control" />
                    <span asp-validation-for="ISBN" class="text-danger"></span>
                </div>
                <label asp-for="CategoryId" class="col-sm-2 col-form-label"></label>
                <div class="col-sm-4">
                    <select asp-for="CategoryId" class="form-control"
                            asp-items="@(new SelectList(Model.Categories,"Id","Name"))">
                        <option>Select ..</option>
                    </select>
                    <span asp-validation-for="CategoryId" class="text-danger"></span>
                </div>
            </div>
            <div class="form-group row">
                <label asp-for="Hardcover" class="col-sm-2 col-form-label"></label>
                <div class="col-sm-4">
                    <input asp-for="Hardcover" class="form-control" />
                    <span asp-validation-for="Hardcover" class="text-danger"></span>
                </div>
                <label asp-for="CopyNum" class="col-sm-2 col-form-label"></label>
                <div class="col-sm-4">
                    <input asp-for="CopyNum" class="form-control" />
                    <span asp-validation-for="CopyNum" class="text-danger"></span>
                </div>
            </div>
            <div class="form-group row">
                <label asp-for="Language" class="col-sm-2 col-form-label"></label>
                <div class="col-sm-4">
                    <input asp-for="Language" class="form-control" />
                    <span asp-validation-for="Language" class="text-danger"></span>
                </div>
                <label asp-for="Copyright" class="col-sm-2 col-form-label"></label>
                <div class="col-sm-4">
                    <input asp-for="Copyright" class="form-control" />
                    <span asp-validation-for="Copyright" class="text-danger"></span>
                </div>
            </div>
            <div class="form-group row">
                <label asp-for="ImageUrl" class="col-sm-2 col-form-label"></label>
                <div class="col-sm-10">
                    <input asp-for="ImageUrl" class="form-control" />
                    <span asp-validation-for="ImageUrl" class="text-danger"></span>
                </div>
            </div>
            <div class="form-group row">
                <label asp-for="Summery" class="col-sm-2 col-form-label"></label>
                <div class="col-sm-10">
                    <textarea asp-for="Summery" rows="5" cols="40" class="form-control"></textarea>
                    <span asp-validation-for="Summery" class="text-danger"></span>
                </div>
            </div>
            <div class="row">
                <div class="offset-2 col-sm-10">
                    <a asp-action="Index" class="btn btn-secondary">Back to List</a>
                    <input type="submit" value="Create" class="btn btn-primary" />
                </div>
            </div>
        </form>
    </div>
</div>

BookManagement.Mvc/Views/Book/Details.cshtml
@model BookManagement.Application.Features.Books.GetBookByIdResponseModel
@{
    ViewData["Title"] = "Details";
}

<div class="row">
    <div class="col-md-4">
        <h3 class="text-center">@Model.Title</h3>
        <img src="@Model.ImageUrl" alt="@Model.Title" style="width:260px;height:300px"/>
    </div>
    <div class="col-md-8">
        <p>@Model.Summery</p>
    </div>
</div>

BookManagement.Mvc/Views/Book/Edit.cshtml
@model BookManagement.Application.Features.Books.Commands.UpdateBookCommand
@{
    ViewData["Title"] = "Edit";
}

<div class="card">
    <div class="card-header">Edit Book</div>
    <div class="card-body">
        <form asp-action="Edit" method="post" autocomplete="off">
            <div class="form-group row">
                <label asp-for="Title" class="col-sm-2 col-form-label"></label>
                <div class="col-sm-4">
                    <input asp-for="Title" class="form-control" />
                    <span asp-validation-for="Title" class="text-danger"></span>
                </div>
                <label asp-for="Publisher" class="col-sm-2 col-form-label"></label>
                <div class="col-sm-4">
                    <input asp-for="Publisher" class="form-control" />
                    <span asp-validation-for="Publisher" class="text-danger"></span>
                </div>
            </div>
            <div class="form-group row">
                <label asp-for="ISBN" class="col-sm-2 col-form-label"></label>
                <div class="col-sm-4">
                    <input asp-for="ISBN" class="form-control" />
                    <span asp-validation-for="ISBN" class="text-danger"></span>
                </div>
                <label asp-for="CategoryId" class="col-sm-2 col-form-label"></label>
                <div class="col-sm-4">
                    <select asp-for="CategoryId" class="form-control"
                            asp-items="@(new SelectList(Model.Categories,"Id","Name"))">
                        <option>Select ..</option>
                    </select>
                    <span asp-validation-for="CategoryId" class="text-danger"></span>
                </div>
            </div>
            <div class="form-group row">
                <label asp-for="Hardcover" class="col-sm-2 col-form-label"></label>
                <div class="col-sm-4">
                    <input asp-for="Hardcover" class="form-control" />
                    <span asp-validation-for="Hardcover" class="text-danger"></span>
                </div>
                <label asp-for="CopyNum" class="col-sm-2 col-form-label"></label>
                <div class="col-sm-4">
                    <input asp-for="CopyNum" class="form-control" />
                    <span asp-validation-for="CopyNum" class="text-danger"></span>
                </div>
            </div>
            <div class="form-group row">
                <label asp-for="Language" class="col-sm-2 col-form-label"></label>
                <div class="col-sm-4">
                    <input asp-for="Language" class="form-control" />
                    <span asp-validation-for="Language" class="text-danger"></span>
                </div>
                <label asp-for="Copyright" class="col-sm-2 col-form-label"></label>
                <div class="col-sm-4">
                    <input asp-for="Copyright" class="form-control" />
                    <span asp-validation-for="Copyright" class="text-danger"></span>
                </div>
            </div>
            <div class="form-group row">
                <label asp-for="ImageUrl" class="col-sm-2 col-form-label"></label>
                <div class="col-sm-10">
                    <input asp-for="ImageUrl" class="form-control" />
                    <span asp-validation-for="ImageUrl" class="text-danger"></span>
                </div>
            </div>
            <div class="form-group row">
                <label asp-for="Summery" class="col-sm-2 col-form-label"></label>
                <div class="col-sm-10">
                    <textarea asp-for="Summery" rows="5" cols="40" class="form-control"></textarea>
                    <span asp-validation-for="Summery" class="text-danger"></span>
                </div>
            </div>
            <div class="row">
                <div class="offset-2 col-sm-10">
                    <a asp-action="Index" class="btn btn-secondary">Back to List</a>
                    <input type="submit" value="Edit" class="btn btn-primary" />
                </div>
            </div>
        </form>
    </div>
</div>

BookManagement.Mvc/Views/Book/Index.cshtml
@model IEnumerable<BookManagement.Application.Features.Books.GetAllBooksResponseModel>

@{
    ViewData["Title"] = "Index";
}

<div class="row" style="margin-bottom:3px;">
    <div class="col-md-2">
        <h4>Books</h4>
    </div>
    <div class="col-md-10 text-right">
        <a asp-action="Create" class="btn btn-success">Create New</a>
    </div>
</div>

@foreach (var item in Model)
{
    <div class="card" style="margin-bottom:10px;">
        <div class="card-body">
            <div class="row">
                <div class="col-md-2">
                    <img src="@item.ImageUrl" alt="@item.Title" style="width:177px;height:218px;margin-bottom:10px;" />
                    @Html.ActionLink("Edit", "Edit", new { id = item.Id })|
                    @Html.ActionLink("Details", "Details", new { id = item.Id })|
                    @Html.ActionLink("Delete", "Delete", new { id = item.Id })
                </div>
                <div class="offset-1 col-md-9">
                    <h3 style="font-size:18px;font-style:italic">@item.Title</h3>
                    <p>ISBN: @item.ISBN</p>
                    <p>Publisher: @item.Publisher</p>
                    <small>@item.Summery</small>
                </div>
            </div>
        </div>
    </div>
}

BookManagement.Mvc/Views/Category/Create.cshtml
@model BookManagement.Application.Features.Categories.Commands.CreateCategory.CreateCategoryCommand
@{
    ViewData["Title"] = "Create";
}

<div class="card">
    <div class="card-header">Create Category</div>
    <div class="card-body">
        <form asp-action="Create" method="post" autocomplete="off">
            <div class="form-group row">
                <label asp-for="Name" class="col-sm-2 col-form-label"></label>
                <div class="col-sm-6">
                    <input asp-for="Name" class="form-control" />
                    <span asp-validation-for="Name" class="text-danger"></span>
                </div>
                <div class="col-sm-4"></div>
            </div>
            <div class="row">
                <div class="offset-2 col-sm-10">
                    <a asp-action="Index" class="btn btn-secondary">Back to List</a>
                    <input type="submit" value="Create" class="btn btn-primary" />
                </div>
            </div>
        </form>
    </div>
</div>

BookManagement.Mvc/Views/Category/Edit.cshtml
@model BookManagement.Application.Features.Categories.Commands.UpdateCategory.UpdateCategoryCommand
@{
    ViewData["Title"] = "Edit";
}

<div class="card">
    <div class="card-header">Edit Category</div>
    <div class="card-body">
        <form asp-action="edit" method="post" autocomplete="off">
            <div class="form-group row">
                <label asp-for="Name" class="col-sm-2 col-form-label"></label>
                <div class="col-sm-6">
                    <input asp-for="Name" class="form-control" />
                    <span asp-validation-for="Name" class="text-danger"></span>
                </div>
                <div class="col-sm-4"></div>
            </div>
            <div class="row">
                <div class="offset-2 col-sm-10">
                    <a asp-action="Index" class="btn btn-secondary">Back to List</a>
                    <input type="submit" value="edit" class="btn btn-primary" />
                </div>
            </div>
        </form>
    </div>
</div>

BookManagement.Mvc/Views/Category/Index.cshtml
@model List<BookManagement.Application.Features.Categories.Queries.GetCategoriesList.CategoryListVm>
@{
    ViewData["Title"] = "Index";
}

<div class="row">
    <div class="col">
        <h1>Categories</h1>
    </div>
    <div class="col text-right">
        <a asp-action="Create" class="btn btn-success">Create New</a>
    </div>
</div>

<br />
<table class="table">
    <thead>
        <tr>
            <th>
                @Html.Name("Title")
            </th>
            <th></th>
        </tr>
    </thead>
    <tbody>
        @foreach (var item in Model)
        {
            <tr>
                <td>
                    @Html.DisplayFor(modelItem => item.Name)
                </td>
                <td>
                    @Html.ActionLink("Edit", "Edit", new { id = item.Id }, new { @class = "btn btn-primary" })
                    @Html.ActionLink("Details", "Details", new { id = item.Id }, new { @class = "btn btn-secondary" })
                    @Html.ActionLink("Delete", "Delete", new { id = item.Id }, new { @class = "btn btn-danger" })
                </td>
            </tr>
        }
    </tbody>
</table>

BookManagement.Mvc/Views/Home/Index.cshtml
@{
    ViewData["Title"] = "Home Page";
}

<div class="text-center">
    <h1 class="display-4">Welcome</h1>
    <p>Learn about <a href="https://docs.microsoft.com/aspnet/core">building Web apps with ASP.NET Core</a>.</p>
</div>

BookManagement.Mvc/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - CleanArchitecture.Mvc</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container">
                <a class="navbar-brand" asp-area="" asp-controller="Book" asp-action="Index">LMS</a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex justify-content-between">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Category" asp-action="Index">Categories</a>
                        </li>
                        @*<li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
                        </li>*@
                    </ul>
                    <partial name="_LoginPartial" />
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2021 - CleanArchitecture.Mvc - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @await RenderSectionAsync("Scripts", required: false)
</body>
</html>